#include <stdlib.h>
#include <math.h>
#include <stdio.h>

/* Some <math.h> files do not define M_PI... */
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define RAGGIO 10
#define STEP 120

#include <GL/glut.h>

typedef struct {
	float x,y,z;
	}point;
int angle=0;

float Pow(float x){ return (x*x);}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

void MidPoint(point a, point b, point* m){
	m->x=(a.x+b.x)/2;
	m->y=(a.y+b.y)/2;
	m->z=(a.z+b.z)/2;
}

void BariCentro(point a, point b,point c, point* m){
	m->x=(a.x+b.x+c.x)/3;
	m->y=(a.y+b.y+c.y)/3;
	m->z=(a.z+b.z+c.z)/3;
}

  /* normalizes v */
void normalize(point*   v   ){
  GLfloat d = sqrt(v->x *v->x  + v->y *v->y  + v->z *v->z );

  if (d == 0) fprintf(stderr, "Zero length vector in normalize\n");
  else{
    v->x  /= d;
    v->y  /= d; 
	v->z  /= d;
  }
 }

  /* calculates a normalized crossproduct to v1, v2 */
void ncrossprod(point v1, point v2,point* cp){
  cp->x  = (v1.y *v2.z) - (v1.z *v2.y) ;
  cp->y  = (v1.z *v2.x) - (v1.x *v2.z);
  cp->z  = (v1.x *v2.y) - (v1.y *v2.x);
  normalize(cp);
}

  /* calculates normal to the triangle designated by a,b,c */
void Normale(point a, point b, point c, point* norm)
{
  point vec1, vec2;

  vec1.x = c.x - a.x;  vec2.x = b.x - a.x;
  vec1.y = c.y - a.y;  vec2.y = b.y - a.y;
  vec1.z = c.z - a.z;  vec2.z = b.z - a.z;

  ncrossprod(vec2, vec1, norm);
  
}

float Lung(point a, point b){
	return( sqrt( Pow(a.x -b.x)+Pow(a.y-b.y)+Pow(a.z-b.z) ) );
}

void Apice(point m1,point m2,point m3,point* api){
float l;
point centro,norm;

	BariCentro(m1,m2,m3,&centro);
	Normale(m1,m2,m3,&norm);
	l=Lung(m1,m2);

//	api->x = centro.x + (norm.x * l * sqrt(3)/2.0);
//	api->y = centro.y + (norm.y * l * sqrt(3)/2.0);
//	api->z = centro.z + (norm.z * l * sqrt(3)/2.0);
	api->x = centro.x + (norm.x * l * sqrt(2.0/3.0)*sin(angle*M_PI/180.0));
	api->y = centro.y + (norm.y * l * sqrt(2.0/3.0)*sin(angle*M_PI/180.0));
	api->z = centro.z + (norm.z * l * sqrt(2.0/3.0)*sin(angle*M_PI/180.0));
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

void Cuspide3d(point a, point b, point c,int level){
point m1,m2,m3,api;

	if(level==0){

		glColor3f(1,1,1);
		Normale(a,b,c,&api);
		glBegin(GL_TRIANGLES);
		glNormal3f(api.x,api.y,api.z);
		glVertex3f(a.x,a.y,a.z);
		glVertex3f(b.x,b.y,b.z);
		glVertex3f(c.x,c.y,c.z);
		glEnd();
							
	}
	else{
		MidPoint(a,b,&m1);
		MidPoint(b,c,&m2);
		MidPoint(c,a,&m3);
		
		Apice(m1,m2,m3,&api);

		Cuspide3d(a,m1,m3,level-1);
		Cuspide3d(m1,b,m2,level-1);
		Cuspide3d(m3,m2,c,level-1);
		Cuspide3d(m3,m1,api,level-1);
		Cuspide3d(m1,m2,api,level-1);
		Cuspide3d(m2,m3,api,level-1);
		
	}
}

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

static void  Key(unsigned char key, int x, int y)
{
  switch (key) {
  case 27:
    exit(0);
  }
}


void  display (void)
{
 
  point tetra[4];

  GLfloat tetraedro[4][3]={
		{ 100.0f, 100.0f, 100.f},
		{-100.0f,-100.0f, 100.f},
		{ 100.0f,-100.0f,-100.f},
		{-100.0f, 100.0f,-100.f}
	};

  
  angle=(angle+3)%360;
  
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
  glLoadIdentity();
  glRotatef(angle,0,1,0);

tetra[0].x=tetraedro[0][0];
tetra[0].y=tetraedro[0][1];
tetra[0].z=tetraedro[0][2];
tetra[1].x=tetraedro[1][0];
tetra[1].y=tetraedro[1][1];
tetra[1].z=tetraedro[1][2];
tetra[2].x=tetraedro[2][0];
tetra[2].y=tetraedro[2][1];
tetra[2].z=tetraedro[2][2];
tetra[3].x=tetraedro[3][0];
tetra[3].y=tetraedro[3][1];
tetra[3].z=tetraedro[3][2];

  Cuspide3d(tetra[3],tetra[0],tetra[2],4);
  Cuspide3d(tetra[2],tetra[0],tetra[1],4);
  Cuspide3d(tetra[1],tetra[0],tetra[3],4);
  Cuspide3d(tetra[1],tetra[3],tetra[2],4);
  
  /*
  glColor3f(1,0,0);	
  glBegin(GL_TRIANGLE_STRIP);
	glVertex3fv(tetraedro[0]);
	glVertex3fv(tetraedro[2]);
	glVertex3fv(tetraedro[1]);
	glVertex3fv(tetraedro[3]);
	
  glEnd();
   */
  glutSwapBuffers();
}



void  myinit (void) {

	  GLfloat light_ambient[] = { 0.0, 0.0, 0.0, 1.0 };
  GLfloat light_diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
  GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };
  GLfloat light_position[] = { 0, 0.5, 5, 0.0 };

  GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };

  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
    
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
  
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LEQUAL);
  glClearColor (0.0, 0.0, 0.0, 1.0);
}

/*  Called when the window is first opened and whenever 
 *  the window is reconfigured (moved or resized).
 */
void  reshape(GLsizei w, GLsizei h)
{
  glMatrixMode (GL_PROJECTION);   /*  prepare for and then  */ 
  glLoadIdentity ();  /*  define the projection  */
  gluPerspective(40.0,(float)w/(float)h,10,1000);
  gluLookAt(400,20,400,0,0,0,0,1,0);
  glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
  glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
}

/*  Main Loop
 *  Open window with initial window size, title bar, 
 *  RGBA display mode, and handle input events.
 */
int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB);
  glutInitWindowSize(512,512);
  glutInitWindowPosition (10, 10);
  
  glutCreateWindow (argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(reshape); 
  glutIdleFunc(display);
  glutKeyboardFunc(Key);	
  
  myinit();
  glutMainLoop();
  return(0);
}








